/***************************************************************************************************
	© 2013 McGladrey LLP  All rights reserved.

McGladrey LLP (McGladrey) grants to Client a limited, non-exclusive, non-transferable right to
install and use the Software/Source Code solely for internal business purposes.  Client may not
distribute, give, rent, loan, or resell a copy of the Software/Source Code to any third party.
McGladrey is the owner of the copyright for the Software/Source Code and McGladrey reserves all
rights related to such ownership.  Any Warranty granted by McGladrey is void if Software/Source Code
is modified by anyone other than McGladrey.

$URL: https://svn.mcgladreycloud.com/repos/NonClient/CSA_iPart/trunk/CSA/SQL/CSA_iPart_install.sql $
$Rev: 7319 $
$Date: 2013-06-07 16:51:56 -0500 (Fri, 07 Jun 2013) $
***************************************************************************************************/
-- Install scripts for CSA iPart

print @@servername + ':' + db_name() + ' - starting at ' + convert(varchar, getdate(), 109)
print ''
go
set nocount on
go

print 'Creating configuration items'
go
if not exists (select * from SystemConfig where SystemConfigKey = '42FDD0CF-9892-4007-9FEC-B2E42FB0AFCF')
begin
	print '-- adding RSM.CSA.License'

	exec asi_InsertSystemConfig 'Organization', 'RSMCustomSettings', 'MANAGER',
		'42FDD0CF-9892-4007-9FEC-B2E42FB0AFCF', 'RSM.CSA.License',
		'85F7051F-0D92-4802-A6CC-74E9B54EA825', 7, 6, 40,
		'License key for Customer Service Alerts iParts',
		'', 100
end
else
begin
	print '-- RSM.CSA.License already exists'
end
go


print 'Adding RuleGroup column to tcsa_AlertDefinitions'
go
if not exists (select 1 from sys.columns c where object_name(c.object_id) = 'tcsa_AlertDefinitions' and c.name = 'RuleGroup')
begin
	print '...Column not present, adding'
	alter table tcsa_AlertDefinitions
		add RuleGroup varchar(100) not NULL default ''
end
else
begin
	print '...RuleGroup already present'
end
go

print 'Creating table tcsa_EventsForTaskCentre'
go
if object_id('tcsa_EventsForTaskCentre') is not NULL
begin
	if (select rows from sysindexes where id = object_id('tcsa_EventsForTaskCentre') and indid < 2) > 0
	begin
		print '***Not deleting - data exists'
	end
	else
	begin
		drop table tcsa_EventsForTaskCentre
	end
end
go
if object_id('tcsa_EventsForTaskCentre') is NULL
begin
	create table tcsa_EventsForTaskCentre
	(
		-- Automatically assigned properties
		Seqn int identity,
		InsertedDate datetime not NULL default getdate(),
		InsertedBy nvarchar(128) not NULL default user_name(),
		OriginDatabase nvarchar(128) not NULL default db_name(),
		
		-- Populated by CSA
		ServerAlias varchar(60) not NULL,			-- Server alias, for compatibility with CSA desktop
		TaskId int not NULL,						-- Task which will handle this event
		UserName varchar(60) not NULL,				-- User who clicked the Action button
		SelectedId varchar(50) not NULL,			-- Contact to which the action applies
		Param1 nvarchar(255) not NULL default '',	-- Optional parameter 1
		Param2 nvarchar(255) not NULL default '',	-- Optional parameter 2
		
		-- Defaulted during insert, task may update
		ProcessedDate datetime NULL,
		ProcessedStatus int not NULL default 0,
		ProcessedMessage nvarchar(255) not NULL default ''
	)
end
go
if object_id('pkcsa_EventsForTaskCentre') is NULL
begin
	alter table tcsa_EventsForTaskCentre
		add constraint pkcsa_EventsForTaskCentre
		primary key clustered (Seqn)
end
go
if not exists (select * from sysindexes where id = object_id('tcsa_EventsForTaskCentre')
		and name = 'icsa_EventsForTaskCentreSelectedId')
begin
	create index icsa_EventsForTaskCentreSelectedId
		on tcsa_EventsForTaskCentre(SelectedId)
end
go
grant select, insert, update, delete, references, view definition on tcsa_EventsForTaskCentre to IMIS
grant select on tcsa_EventsForTaskCentre to public
go



go
print ''
print @@servername + ':' + db_name() + ' - finished at ' + convert(varchar, getdate(), 109)
print ''
go
